## Get backbone conformation according to helpars ##
#!/usr/bin/env Rscript
#args = commandArgs(trailingOnly=TRUE)

correct_bkb_states = function(seq_file,in_folder,first_snap,last_snap)
{


resC = get(load('Data/Results_miniabc_K_Crick_helpars_prob_bkb_500k_new.Rdata'))	# Probability of BI
resW = get(load('Data/Results_miniabc_K_Watson_helpars_prob_bkb_500k_new.Rdata'))


res_C = get(load('Data/Results_miniabc_K_Crick_helpars_class_bkb_500k_new.Rdata'))	# Crick
class_errC = res_C[,c(3,6,9,12,15,18)]
for(i in 1:length(class_errC[,1])) class_errC[i,class_errC[i,] == "0"] = "1"
minsC = unlist(lapply(1:length(class_errC[,1]), function(i) min(class_errC[i,class_errC[i,]>0])))
index_minsC = unlist(lapply(1:length(minsC), function(i) which(class_errC[i,] == minsC[i])[1]))


res_W = get(load('Data/Results_miniabc_K_helpars_class_bkb_500k_new.Rdata'))	# Watson
class_errW = res_W[,c(3,6,9,12,15,18)]
for(i in 1:length(class_errW[,1])) class_errW[i,class_errW[i,] == "0"] = "1"
minsW = unlist(lapply(1:length(class_errW[,1]), function(i) min(class_errW[i,class_errW[i,]>0])))
index_minsW = unlist(lapply(1:length(minsW), function(i) which(class_errW[i,] == minsW[i])[1]))



tets = res_W[,1]

#seq_file = "~/Programs/DNA_multimodal/src/seq_56merTIP3P.dat"
#seq_file = as.character(args[1])
#in_folder = "/orozco/projects/MontecarloJurgen/data/56merTIP3P/bsc1_k_avg_miniabc"
#in_folder = as.character(args[2])
#out_folder = as.character(args[3])

hel_file = paste0(in_folder,"/output_helpar")
hel_files = list.files(hel_file,full.names=T)
hel_files_ord = hel_files[c(3,4,1,5,2,6)]
hels_all = lapply(hel_files_ord, function(i) read.table(i))

hel_ord = lapply(1:length(hels_all[[1]][,1]), function(x) cbind(as.numeric(hels_all[[1]][x,]),as.numeric(hels_all[[2]][x,]),as.numeric(hels_all[[3]][x,]),as.numeric(hels_all[[4]][x,]),as.numeric(hels_all[[5]][x,]),as.numeric(hels_all[[6]][x,])))	# hels_ord[[snapshot]][bps,helpar]

seq = scan(sprintf("%s",seq_file), what="string", sep=NULL)

seq_indsteps = sapply(1:(nchar(seq)), function(i) substr(seq, start=i, stop=(i)))
seq_bpsteps = sapply(1:(nchar(seq)-1), function(i) substr(seq, start=i, stop=(i+1)))
seq_tetsteps = sapply(1:(nchar(seq)-3), function(i) substr(seq, start=i, stop=(i+3)))


r_y = function(x){
x[x == "A"] <- "R"
x[x == "G"] <- "R"
x[x == "T"] <- "Y"
x[x == "C"] <- "Y"
x
		}

ry_step = function(x){
if(x == "AA" | x == 'AG' | x== 'GG' | x == "GA") y <- "RR"
if(x == "GT" | x =='GC' | x=='AT' | x=='AC') y <- "RY"
if(x == "TA" | x=='TG' | x=='CA' | x=='CG') y <- "YR"
if(x == "CT" | x=='CC' | x=='TC' | x=='TT') y <- "YY"
y
		}


invert_tet = function(tet)
{
n = 1
a = sapply(seq(1,nchar(tet),by=n), function(x) substr(tet, x, x+n-1))

	invert = function(j)
	{
	if(a[j] == "A") a[j] = "T"
	else if(a[j] == "T") a[j] = "A"
	else if(a[j] == "C") a[j] = "G"
	else if(a[j] == "G") a[j] = "C"
	return(a[j])
	}
	b = unlist(lapply(1:4,invert))

out = paste(rev(b),collapse="")
return(out)
}


all_snapshots = function(snap)
{

hels = hel_ord[[snap]]
#print(snap)
get_bkb_state = function(ind,hels)
{
#print(ind)
ry = ry_step(seq_bpsteps[ind+1])
indbp = ind+1

if(seq_tetsteps[ind] %in% tets){rev = 0
				a = which(tets %in% seq_tetsteps[ind])
				}else{
					rev = 1	
					a = which(tets %in% invert_tet(seq_tetsteps[ind]))
					}


distrW = resW[[a]]
distrW = distrW[distrW[,1] > -1,]
distrC = resC[[a]]
distrC = distrC[distrC[,1] > -1,]

if(rev == 0)
{


# Watson
indexW = index_minsW[a] # 1:shift,2:slide,3:twist,4:sh5,5:tw5,6:sh3
if(indexW == 1) helpar = hels[indbp,1]
if(indexW == 2) helpar = hels[indbp,2]
if(indexW == 3) helpar = hels[indbp,6]
if(indexW == 4) helpar = hels[(indbp-1),1]
if(indexW == 5) helpar = hels[(indbp-1),6]
if(indexW == 6) helpar = hels[(indbp+1),1]



for(i in 1:(length(distrW[,1])-1)) if(helpar > distrW[i,2] & helpar <= distrW[i+1,2]) bW = distrW[i+1,1]
if(helpar <= distrW[1,2]) bW = distrW[1,1]
if(helpar > distrW[length(distrW[,1]),2]) bW = distrW[1,1]

# Crick
indexC = index_minsC[a] # 1:shift,2:slide,3:twist,4:sh5,5:tw5,6:sh3
if(indexC == 1) helpar = hels[indbp,1]
if(indexC == 2) helpar = hels[indbp,2]
if(indexC == 3) helpar = hels[indbp,6]
if(indexC == 4) helpar = hels[(indbp-1),1]
if(indexC == 5) helpar = hels[(indbp-1),6]
if(indexC == 6) helpar = hels[(indbp+1),1]

distr = resC[[a]]

for(i in 1:(length(distrC[,1])-1)) if(helpar > distrC[i,2] & helpar <= distrC[i+1,2]) bC = distrC[i+1,1]
if(helpar <= distrC[1,2]) bC = distrC[1,1]
if(helpar > distrC[length(distrC[,1]),2]) bC = distrC[1,1]

out = c(bW,bC)
if(ry == "YY") out = c(bC,bW)	# To turn around bkb states


}	# IF rev

if(rev == 1)
{


if(ry == "RY" | ry == "YR")
{
# Watson
indexW = index_minsW[a] # 1:shift,2:slide,3:twist,4:sh5,5:tw5,6:sh3
if(indexW == 1) helpar = hels[indbp,1]
if(indexW == 2) helpar = hels[indbp,2]
if(indexW == 3) helpar = hels[indbp,6]
if(indexW == 4) helpar = hels[(indbp-1),1]
if(indexW == 5) helpar = hels[(indbp-1),6]
if(indexW == 6) helpar = hels[(indbp+1),1]

distr = resW[[a]]

for(i in 1:(length(distrW[,1])-1)) if(helpar > distrW[i,2] & helpar <= distrW[i+1,2]) bW = distrW[i+1,1]
if(helpar <= distrW[1,2]) bW = distrW[1,1]
if(helpar > distrW[length(distrW[,1]),2]) bW = distrW[1,1]


# Crick
indexC = index_minsC[a] # 1:shift,2:slide,3:twist,4:sh5,5:tw5,6:sh3
if(indexC == 1) helpar = hels[indbp,1]
if(indexC == 2) helpar = hels[indbp,2]
if(indexC == 3) helpar = hels[indbp,6]
if(indexC == 4) helpar = hels[(indbp-1),1]
if(indexC == 5) helpar = hels[(indbp-1),6]
if(indexC == 6) helpar = hels[(indbp+1),1]


for(i in 1:(length(distrC[,1])-1)) if(helpar > distrC[i,2] & helpar <= distrC[i+1,2]) bC = distrC[i+1,1]
if(helpar <= distrC[1,2]) bC = distrC[1,1]
if(helpar > distrC[length(distrC[,1]),2]) bC = distrC[1,1]
out = c(bC,bW)

} else {	# for RR and YY

# Watson
indexW = index_minsW[a] # 1:shift,2:slide,3:twist,4:sh5,5:tw5,6:sh3
if(indexW == 1) helpar = -hels[indbp,1]		# former -
if(indexW == 2) helpar = hels[indbp,2]
if(indexW == 3) helpar = hels[indbp,6]
if(indexW == 4) helpar = -hels[(indbp-1),1]		# former -
if(indexW == 5) helpar = hels[(indbp-1),6]
if(indexW == 6) helpar = -hels[(indbp+1),1]		# former -


for(i in 1:(length(distrW[,1])-1)) if(helpar > distrW[i,2] & helpar <= distrW[i+1,2]) bW = distrW[i+1,1]
if(helpar <= distrW[1,2]) bW = distrW[1,1]
if(helpar > distrW[length(distrW[,1]),2]) bW = distrW[1,1]


# Crick
indexC = index_minsC[a] # 1:shift,2:slide,3:twist,4:sh5,5:tw5,6:sh3
if(indexC == 1) helpar = -hels[indbp,1]	# former -
if(indexC == 2) helpar = hels[indbp,2]
if(indexC == 3) helpar = hels[indbp,6]
if(indexC == 4) helpar = -hels[(indbp-1),1]		# former -
if(indexC == 5) helpar = hels[(indbp-1),6]
if(indexC == 6) helpar = -hels[(indbp+1),1]		# former -

distr = resC[[a]]


for(i in 1:(length(distrC[,1])-1)) if(helpar > distrC[i,2] & helpar <= distrC[i+1,2]) bC = distrC[i+1,1]
if(helpar <= distrC[1,2]) bC = distrC[1,1]
if(helpar > distrC[length(distrC[,1]),2]) bC = distrC[1,1]


out = c(bW,bC)	#before (bC,bW)
if(ry == "YY") out = c(bC,bW)
}


}	# IF rev


return(out)
}	# get_bkb_state

res_all = do.call("rbind",lapply(1:length(seq_tetsteps),get_bkb_state, hels))

return(res_all)
}	# all_snapshots


#all_snps = lapply(1:length(hel_ord), all_snapshots)	# only if for all snapshots wanted
all_snps = lapply(first_snap:last_snap, all_snapshots)



assign_bkb_state = function(x)
{
rnd1 = runif(length(seq_tetsteps),0.0,1.0)
rnd2 = runif(length(seq_tetsteps),0.0,1.0)
rnd = cbind(rnd1,rnd2)

assgn = rnd < x	# BI: TRUE; BII: FALSE

res_assgn = assgn

## Check for consecutive BII
#print(assgn)
#print(x)
# Three consecutive BII
for(col in 1:2){
for(i in 1:(length(assgn[,1])-2)){
if(assgn[i,col] == F & assgn[i+1,col] == F & assgn[i+2,col] == F){	
					if(runif(1,0.0,1.0) < x[i+1,col]/(x[i,col]+x[i+1,col]+x[i+2,col]+1e-07)){assgn[i+1,col] = T}else{
														assgn[i,col] = T
														assgn[i+2,col] = T
																}
					   }
				  }

		}



# Two consecutive BII
for(col in 1:2){
for(i in 1:(length(assgn[,1])-1)){
if(assgn[i,col] == F & assgn[i+1,col] == F){		
					if(runif(1,0.0,1.0) < x[i,col]/(x[i,col]+x[i+1,col]+1e-07)) assgn[i,col] = T else assgn[i+1,col] = T
					   }
				  }
		}



return(assgn)
}


out_assgn = lapply(all_snps, assign_bkb_state)


return(out_assgn)	# Output of overall function
}


