#!/bin/bash
seq_file=$1
out_folder=$2

a=$(wc -m "$seq_file" | cut -d' ' -f1)
b=`echo "$a - 1" | bc`	#length of one strand
c=`echo "$b + $b" | bc`	#number of all bases
d=`echo "$b - 2" | bc`
e=`echo "$b + 2" | bc`
f=`echo "$c - 2" | bc`

echo "Minimization - just 50 steepest descent steps with restraints" > "$out_folder"/min.in
echo "&cntrl" >> $out_folder/min.in
echo "   imin=1,maxcyc=50, ncyc=50," >> $out_folder/min.in
echo "   ntpr=5, ntb=0, igb=0, cut=12," >> $out_folder/min.in
echo "   nmropt=0, ntxo=1," >> $out_folder/min.in
echo "   ntr=1," >> $out_folder/min.in
echo "   restraint_wt = 100," >> $out_folder/min.in
echo "   restraintmask = '(:2-$d,$e-$f) & (@P,O3'',C3'',O5'')'" >> $out_folder/min.in
echo "&end" >> $out_folder/min.in
