#!/bin/bash
folder=$1
traj_name=$2
top_file=$3
seq_file=$4

#ulimit -s 200000
cd $folder/output_pdb/bkb
out="minimize/"
mkdir $out
mkdir rebuilt
top_path=$folder/output_pdb/bkb/$out

min_ending=".phedit_rebuilt_min"

# Get Topology file
name_ind="structure_000000rec"
  echo "m = loadpdb "$name_ind".pdb" > tleap_top.in
  echo "savepdb m rebuilt/"$name_ind".rebuilt.pdb" >> tleap_top.in
  echo "n = loadpdb "rebuilt/$name_ind".rebuilt.pdb" >> tleap_top.in
  echo "saveamberparm n "$top_path""$top_file".prmtop "$top_path""$top_file".inpcrd" >> tleap_top.in
  echo "quit" >> tleap_top.in

  tleap -s -f $AMBERHOME/dat/leap/cmd/leaprc.ff14SB -f tleap_top.in


rm tleap_top.in
cp "$top_path"/"$top_file".prmtop rebuilt/
cp "$top_path"/"$top_file".prmtop "$top_path"/"$top_file".top 


#for i in $(ls -1 *rec.pdb | head -10); do
for i in $(ls -1 *rec.pdb); do
  name=$(basename $i .pdb)
  file_top=$out$(basename $i .pdb)
  file_crd=$out$(basename $i .pdb)
  file_out=$out$(basename $i .pdb)
  file_pdb=$out$name

  echo "m = loadpdb "$name".pdb" > tleap.in
  echo "saveamberparm m "$file_top".prmtop "$file_crd".inpcrd" >> tleap.in
  echo "savepdb m "$name".rebuilt.pdb" >> tleap.in
  echo "quit" >> tleap.in

  tleap -s -f $AMBERHOME/dat/leap/cmd/leaprc.ff14SB -f tleap.in
 
  sander -O -i min.in -ref "$file_crd".inpcrd -o "$file_out".out -p "$file_top".prmtop -c "$file_crd".inpcrd -r "$file_out".rst
  ambpdb -p "$file_top".prmtop < "$file_out".rst > "$file_pdb""$min_ending".pdb
done

rm tleap.in
cd $out
rm *.prmtop
rm *.inpcrd
rm *.rst
rm *.out

cp "$top_path"/"$top_file".top rebuilt/

#Create traj

rm make_traj_cpptraj.in
#rm *.mdcrd

a=$(wc -m "$seq_file" | cut -d' ' -f1)
b=`echo "$a - 1" | bc`
c=`echo "$b + $b" | bc`

for i in $(ls -1 *"$min_ending".pdb); do
  name=$(basename $i .pdb)
  echo "trajin "$name".pdb" >> make_traj_cpptraj.in
done
  echo "reference "$name_ind""$min_ending".pdb" >> make_traj_cpptraj.in
  echo "rms reference :1-"$c"@N1,C2,O2,N3,C4,N4,C5,C6,N9,C8,N7,O6,N2,N6,O4"  >> make_traj_cpptraj.in
  echo "trajout "$traj_name".mdcrd mdcrd" >> make_traj_cpptraj.in
  echo "go" >> make_traj_cpptraj.in

  cpptraj -p "$top_file".top < make_traj_cpptraj.in

#rm make_traj_cpptraj.in
