#!/bin/bash
SCHNA_AR_P="$PWD"/SCHNArP
export SCHNA_AR_P
ulimit -s 50000
seq_file=$1
num_strucs=$2
folder=$3
echo "MC-DNA program in coarse-grain resolution starting..."
mkdir $folder
mkdir $folder/output_pdb $folder/output_helpar
./MC_DNA $seq_file $num_strucs $folder

echo "MC-DNA program in coarse-grain resolution finished. Atomistic reconstruction starting..."

mkdir $folder/output_pdb/bkb

cd Backbone_reconstruction
sh create_min_file.sh $seq_file $folder/output_pdb/bkb
Rscript reconstruct_bkb.R $seq_file $folder $num_strucs

rm $folder/pred_bkb_states.Rdata

top_file="out"
traj_name="out"
sh rec_bkb.sh $folder $traj_name $top_file $seq_file

cp $folder/output_pdb/bkb/minimize/out.top $folder/output_pdb/bkb/minimize/out.mdcrd $folder/output_pdb
rm $folder/output_pdb/*.pdb
rm -r $folder/output_pdb/bkb

echo "Atomistic reconstruction finished. You can view 'out.top' and 'out.mdcrd' (both in AMBER format) in the 'output_pdb' folder."
